/*  OpenTally: Open-source election vote counting
 *  Copyright © 2021 Lee Yingtong Li (RunasSudo)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

mod utils;

use opentally::numbers::NativeFloat64;
use opentally::stv;

#[test]
fn csm15_float64() {
	let stv_opts = stv::STVOptions {
		round_tvs: None,
		round_weights: None,
		round_votes: None,
		round_quota: Some(0),
		sum_surplus_transfers: stv::SumSurplusTransfersMode::SingleStep,
		meek_surplus_tolerance: String::new(),
		normalise_ballots: false,
		quota: stv::QuotaType::Droop,
		quota_criterion: stv::QuotaCriterion::GreaterOrEqual,
		quota_mode: stv::QuotaMode::Static,
		ties: vec![],
		surplus: stv::SurplusMethod::WIG,
		surplus_order: stv::SurplusOrder::BySize,
		transferable_only: false,
		exclusion: stv::ExclusionMethod::Wright,
		meek_nz_exclusion: false,
		bulk_exclude: true,
		defer_surpluses: false,
		meek_immediate_elect: false,
		pp_decimals: 2,
	};
	utils::read_validate_election::<NativeFloat64>("tests/data/CSM15.csv", "tests/data/CSM15.blt", stv_opts, Some(6), &["quota"]);
}
